"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from livepeer.types import BaseModel
import pydantic
from typing import Dict, Optional, TypedDict, Union
from typing_extensions import Annotated, NotRequired


class One(int, Enum):
    r"""0: not mobile, 1: mobile screen share, 2: mobile camera."""

    ZERO = 0
    ONE = 1
    TWO = 2


IsMobileTypedDict = Union[One, bool]
r"""Indicates whether the stream will be pulled from a mobile source."""


IsMobile = Union[One, bool]
r"""Indicates whether the stream will be pulled from a mobile source."""


class LocationTypedDict(TypedDict):
    r"""Approximate location of the pull source. The location is used to
    determine the closest Livepeer region to pull the stream from.
    """

    lat: float
    r"""Latitude of the pull source in degrees. North is positive,
    south is negative.
    """
    lon: float
    r"""Longitude of the pull source in degrees. East is positive,
    west is negative.
    """


class Location(BaseModel):
    r"""Approximate location of the pull source. The location is used to
    determine the closest Livepeer region to pull the stream from.
    """

    lat: float
    r"""Latitude of the pull source in degrees. North is positive,
    south is negative.
    """

    lon: float
    r"""Longitude of the pull source in degrees. East is positive,
    west is negative.
    """


class PullTypedDict(TypedDict):
    r"""Configuration for a stream that should be actively pulled from an
    external source, rather than pushed to Livepeer. If specified, the
    stream will not have a streamKey.
    """

    source: str
    r"""URL from which to pull from."""
    headers: NotRequired[Dict[str, str]]
    r"""Headers to be sent with the request to the pull source."""
    is_mobile: NotRequired[IsMobileTypedDict]
    r"""Indicates whether the stream will be pulled from a mobile source."""
    location: NotRequired[LocationTypedDict]
    r"""Approximate location of the pull source. The location is used to
    determine the closest Livepeer region to pull the stream from.
    """


class Pull(BaseModel):
    r"""Configuration for a stream that should be actively pulled from an
    external source, rather than pushed to Livepeer. If specified, the
    stream will not have a streamKey.
    """

    source: str
    r"""URL from which to pull from."""

    headers: Optional[Dict[str, str]] = None
    r"""Headers to be sent with the request to the pull source."""

    is_mobile: Annotated[Optional[IsMobile], pydantic.Field(alias="isMobile")] = None
    r"""Indicates whether the stream will be pulled from a mobile source."""

    location: Optional[Location] = None
    r"""Approximate location of the pull source. The location is used to
    determine the closest Livepeer region to pull the stream from.
    """
