"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from livepeer.types import BaseModel
import pydantic
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class SigningKeyTypedDict(TypedDict):
    public_key: str
    id: NotRequired[str]
    name: NotRequired[str]
    r"""Name of the signing key"""
    user_id: NotRequired[str]
    created_at: NotRequired[float]
    r"""Timestamp (in milliseconds) at which the signing-key was created"""
    last_seen: NotRequired[float]
    r"""Timestamp (in milliseconds) at which the signing-key was last used"""
    disabled: NotRequired[bool]
    r"""Disable the signing key to allow rotation safely"""
    project_id: NotRequired[str]
    r"""The ID of the project"""


class SigningKey(BaseModel):
    public_key: Annotated[str, pydantic.Field(alias="publicKey")]

    id: Optional[str] = None

    name: Optional[str] = None
    r"""Name of the signing key"""

    user_id: Annotated[
        Optional[str],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible.",
            alias="userId",
        ),
    ] = None

    created_at: Annotated[Optional[float], pydantic.Field(alias="createdAt")] = None
    r"""Timestamp (in milliseconds) at which the signing-key was created"""

    last_seen: Annotated[Optional[float], pydantic.Field(alias="lastSeen")] = None
    r"""Timestamp (in milliseconds) at which the signing-key was last used"""

    disabled: Optional[bool] = None
    r"""Disable the signing key to allow rotation safely"""

    project_id: Annotated[Optional[str], pydantic.Field(alias="projectId")] = None
    r"""The ID of the project"""
