"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from livepeer.types import BaseModel
import pydantic
from typing import Dict, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class RequestTypedDict(TypedDict):
    url: NotRequired[str]
    r"""URL used for the request"""
    method: NotRequired[str]
    r"""HTTP request method"""
    headers: NotRequired[Dict[str, str]]
    r"""HTTP request headers"""
    body: NotRequired[str]
    r"""request body"""


class Request(BaseModel):
    url: Optional[str] = None
    r"""URL used for the request"""

    method: Optional[str] = None
    r"""HTTP request method"""

    headers: Optional[Dict[str, str]] = None
    r"""HTTP request headers"""

    body: Optional[str] = None
    r"""request body"""


class ResponseTypedDict(TypedDict):
    body: NotRequired[str]
    r"""response body"""
    status: NotRequired[float]
    r"""HTTP status code"""
    status_text: NotRequired[str]
    r"""response status text"""


class Response(BaseModel):
    body: Optional[str] = None
    r"""response body"""

    status: Optional[float] = None
    r"""HTTP status code"""

    status_text: Annotated[Optional[str], pydantic.Field(alias="statusText")] = None
    r"""response status text"""


class WebhookLogTypedDict(TypedDict):
    id: str
    webhook_id: str
    r"""ID of the webhook this request was made for"""
    event: NotRequired[str]
    r"""The event type that triggered the webhook request"""
    created_at: NotRequired[float]
    r"""Timestamp (in milliseconds) at which webhook request object was
    created

    """
    duration: NotRequired[float]
    r"""The time taken (in seconds) to make the webhook request"""
    success: NotRequired[bool]
    r"""Whether the webhook request was successful"""
    request: NotRequired[RequestTypedDict]
    response: NotRequired[ResponseTypedDict]


class WebhookLog(BaseModel):
    id: str

    webhook_id: Annotated[str, pydantic.Field(alias="webhookId")]
    r"""ID of the webhook this request was made for"""

    event: Optional[str] = None
    r"""The event type that triggered the webhook request"""

    created_at: Annotated[Optional[float], pydantic.Field(alias="createdAt")] = None
    r"""Timestamp (in milliseconds) at which webhook request object was
    created

    """

    duration: Optional[float] = None
    r"""The time taken (in seconds) to make the webhook request"""

    success: Optional[bool] = None
    r"""Whether the webhook request was successful"""

    request: Optional[Request] = None

    response: Optional[Response] = None
