"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from livepeer.models.components import (
    httpmetadata as components_httpmetadata,
    signing_key as components_signing_key,
)
from livepeer.models.errors import error as errors_error
from livepeer.types import BaseModel
from livepeer.utils import FieldMetadata, PathParamMetadata
import pydantic
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class GetSigningKeyRequestTypedDict(TypedDict):
    key_id: str
    r"""ID of the signing key"""


class GetSigningKeyRequest(BaseModel):
    key_id: Annotated[
        str,
        pydantic.Field(alias="keyId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""ID of the signing key"""


class GetSigningKeyResponseTypedDict(TypedDict):
    http_meta: components_httpmetadata.HTTPMetadataTypedDict
    signing_key: NotRequired[components_signing_key.SigningKeyTypedDict]
    r"""Success"""
    error: NotRequired[errors_error.Error]
    r"""Error"""


class GetSigningKeyResponse(BaseModel):
    http_meta: Annotated[
        Optional[components_httpmetadata.HTTPMetadata], pydantic.Field(exclude=True)
    ] = None

    signing_key: Optional[components_signing_key.SigningKey] = None
    r"""Success"""

    error: Optional[errors_error.Error] = None
    r"""Error"""
