"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from livepeer.models.components import (
    asset as components_asset,
    httpmetadata as components_httpmetadata,
)
from livepeer.models.errors import error as errors_error
from livepeer.types import BaseModel
import pydantic
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class UploadAssetAssetTaskTypedDict(TypedDict):
    id: str


class UploadAssetAssetTask(BaseModel):
    id: str


class UploadAssetDataOutputTypedDict(TypedDict):
    r"""Upload started"""

    asset: components_asset.AssetTypedDict
    task: UploadAssetAssetTaskTypedDict


class UploadAssetDataOutput(BaseModel):
    r"""Upload started"""

    asset: components_asset.Asset

    task: UploadAssetAssetTask


class UploadAssetTaskTypedDict(TypedDict):
    id: str


class UploadAssetTask(BaseModel):
    id: str


class UploadAssetDataTypedDict(TypedDict):
    r"""Upload in progress"""

    asset: components_asset.AssetTypedDict
    task: UploadAssetTaskTypedDict


class UploadAssetData(BaseModel):
    r"""Upload in progress"""

    asset: components_asset.Asset

    task: UploadAssetTask


class UploadAssetResponseTypedDict(TypedDict):
    http_meta: components_httpmetadata.HTTPMetadataTypedDict
    two_hundred_application_json_data: NotRequired[UploadAssetDataTypedDict]
    r"""Upload in progress"""
    two_hundred_and_one_application_json_data: NotRequired[
        UploadAssetDataOutputTypedDict
    ]
    r"""Upload started"""
    error: NotRequired[errors_error.Error]
    r"""Error"""


class UploadAssetResponse(BaseModel):
    http_meta: Annotated[
        Optional[components_httpmetadata.HTTPMetadata], pydantic.Field(exclude=True)
    ] = None

    two_hundred_application_json_data: Optional[UploadAssetData] = None
    r"""Upload in progress"""

    two_hundred_and_one_application_json_data: Optional[UploadAssetDataOutput] = None
    r"""Upload started"""

    error: Optional[errors_error.Error] = None
    r"""Error"""
