"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .ffmpeg_profile import FfmpegProfile, FfmpegProfileTypedDict
from .input_creator_id import InputCreatorID, InputCreatorIDTypedDict
from .multistream import Multistream, MultistreamTypedDict
from .playback_policy import PlaybackPolicy, PlaybackPolicyTypedDict
from .recordingspec import RecordingSpec, RecordingSpecTypedDict
from .usertags import UserTags, UserTagsTypedDict
from livepeer.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
import pydantic
from pydantic import model_serializer
from typing import Dict, List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class StreamPatchPayloadTypedDict(TypedDict):
    creator_id: NotRequired[InputCreatorIDTypedDict]
    record: NotRequired[bool]
    r"""Should this stream be recorded? Uses default settings. For more
    customization, create and configure an object store.

    """
    suspended: NotRequired[bool]
    r"""If currently suspended"""
    multistream: NotRequired[MultistreamTypedDict]
    playback_policy: NotRequired[Nullable[PlaybackPolicyTypedDict]]
    r"""Whether the playback policy for an asset or stream is public or signed"""
    profiles: NotRequired[Nullable[List[FfmpegProfileTypedDict]]]
    recording_spec: NotRequired[RecordingSpecTypedDict]
    user_tags: NotRequired[Dict[str, UserTagsTypedDict]]
    r"""User input tags associated with the stream"""


class StreamPatchPayload(BaseModel):
    creator_id: Annotated[
        Optional[InputCreatorID], pydantic.Field(alias="creatorId")
    ] = None

    record: Optional[bool] = None
    r"""Should this stream be recorded? Uses default settings. For more
    customization, create and configure an object store.

    """

    suspended: Optional[bool] = None
    r"""If currently suspended"""

    multistream: Optional[Multistream] = None

    playback_policy: Annotated[
        OptionalNullable[PlaybackPolicy], pydantic.Field(alias="playbackPolicy")
    ] = UNSET
    r"""Whether the playback policy for an asset or stream is public or signed"""

    profiles: OptionalNullable[List[FfmpegProfile]] = UNSET

    recording_spec: Annotated[
        Optional[RecordingSpec], pydantic.Field(alias="recordingSpec")
    ] = None

    user_tags: Annotated[
        Optional[Dict[str, UserTags]], pydantic.Field(alias="userTags")
    ] = None
    r"""User input tags associated with the stream"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "creatorId",
            "record",
            "suspended",
            "multistream",
            "playbackPolicy",
            "profiles",
            "recordingSpec",
            "userTags",
        ]
        nullable_fields = ["playbackPolicy", "profiles"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
